namespace org.accordproject.patent;
using org.accordproject.address;
using org.accordproject.geo;
using org.accordproject.person;
using org.accordproject.usa.residency;
using AccordProject.Concerto;
[AccordProject.Concerto.Type(Namespace = "org.accordproject.patent", Version = "0.2.0", Name = "PatentAssetIdentifier")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class PatentAssetIdentifier : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.patent@0.2.0.PatentAssetIdentifier";
   public string assetNumber { get; set; }
   public AssetNumberStatus numberStatus { get; set; }
   public Country? assetCountry { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.patent", Version = "0.2.0", Name = "PatentClassification")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class PatentClassification : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.patent@0.2.0.PatentClassification";
   public string classificationSymbol { get; set; }
   public string classificationDescription { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.patent", Version = "0.2.0", Name = "Inventor")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Inventor : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.patent@0.2.0.Inventor";
   public Country? residentCountry { get; set; }
   public Residency? inventorResidency { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.patent", Version = "0.2.0", Name = "Applicant")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Applicant : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.patent@0.2.0.Applicant";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.patent", Version = "0.2.0", Name = "Assignee")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Assignee : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.patent@0.2.0.Assignee";
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum AssetNumberStatus {
      APP,
      PAT,
      PUB,
      REISS,
      FOR,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum ApplicationType {
      PROV,
      NONPROV,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum SubjectMatter {
      UTILITY,
      PLANT,
      DESIGN,
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.patent", Version = "0.2.0", Name = "PatentAsset")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class PatentAsset : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.patent@0.2.0.PatentAsset";
   public PatentAssetIdentifier[] assetIdentifier { get; set; }
   public string title { get; set; }
   public Inventor?[] inventorIdentifier { get; set; }
   public Applicant? applicantIdentifier { get; set; }
   public Assignee? currentAssignee { get; set; }
   public Assignee? originalAssignee { get; set; }
   public System.DateTime? priorityDate { get; set; }
   public System.DateTime? filingDate { get; set; }
   public System.DateTime? issueDate { get; set; }
   public System.DateTime? publicationDate { get; set; }
   public PatentClassification?[] classifier { get; set; }
   public string attorneyDocketNumber { get; set; }
   public string customerNumber { get; set; }
   public string[] emailAddress { get; set; }
   public ApplicationType? applicationType { get; set; }
   public SubjectMatter? subjectMatter { get; set; }
   public float? numDrawings { get; set; }
   public float? pubFigure { get; set; }
   public PatentAsset?[] priorApplication { get; set; }
}
